r"""
This script lives on the photo frame and listens for commands from the server.
The master file is saved on my macbook amp:~/mqtt-daemon.py

export XDG_RUNTIME_DIR=/run/user/1000
export WAYLAND_DISPLAY=wayland-1

#sudo -u <username> <command>
sudo -u username bash -c /home/username/logon.sh

sudo -u username bash -c WAYLAND_DISPLAY=wayland-1 XDG_RUNTIME_DIR=/run/user/1000 id
"""

import paho.mqtt.client as mqtt
import subprocess


def on_message(client, userdata, message):
    try:
        command = message.payload.decode("utf-8")
    except UnicodeDecodeError as e:
        print(f"Error decoding message: {e}")
        return

    result = None

    # Set environment variables
    env = {"XDG_RUNTIME_DIR": "/run/user/1000", "WAYLAND_DISPLAY": "wayland-1"}

    print(f"Received command: {command}")
    # Execute the command
    #    result = subprocess.run(command, shell=True, capture_output=True)
    #    print("Command output:")
    #    print(result.stdout.decode())
    #    print("Command errors:")
    #    print(result.stderr.decode())
    #    print("===================================")

    print(f"MQTT command: {command}")

    if command == "monitor_on":
        result = subprocess.run(
            "/usr/bin/wlr-randr --output HDMI-A-1 --on", shell=True, capture_output=True, env=env
        )

    if command == "monitor_off":
        result = subprocess.run(
            "/usr/bin/wlr-randr --output HDMI-A-1 --off", shell=True, capture_output=True, env=env
        )

    if "brightness" in command:
        value = command.split(" ")[1]
        print(f"brightness val : {value}")
        result = subprocess.run(
            f"ddcutil setvcp 10 {value}", shell=True, capture_output=True, env=env
        )

    if "restart_browser" in command:
        result = subprocess.run(
            "killall chromium-browser",
            shell=True,
            capture_output=True,
        )

        # result = subprocess.run(
        #     "sudo -u username bash -c 'export DISPLAY=:0; /home/username/logon.sh'",
        #     shell=True,
        #     capture_output=True,
        # )

        # Start the subprocess asynchronously. For some reason it hangs the script if not.
        subprocess.Popen(
            "sudo -u username bash -c 'export DISPLAY=:0; /home/username/logon.sh'",
            shell=True,
            stdout=subprocess.DEVNULL,
            stderr=subprocess.DEVNULL,
            close_fds=True,
        )

    if result:
        print("Command output:")
        print(result.stdout.decode())
        print("Command errors:")
        print(result.stderr.decode())

    print("DONE WITH LOOP ==============================")


client = mqtt.Client()
client.on_message = on_message

client.connect("10.5.0.60")
client.subscribe("photo_frame/command")
client.loop_forever()
